#include "cbfcmn.h"

void
cbf_read ( barray, nbytes, iret )
	unsigned char	*barray;
	int		*nbytes;
	int		*iret;

/************************************************************************
 * cbf_read								*
 *									*
 * This function reads an entire message from a BUFR file.		*
 *									*
 * cbf_read ( barray, nbytes, iret )					*
 *									*
 * Output parameters:							*
 *	*barray		unsigned char	Byte array			*
 *	*nbytes		int		Number of bytes			*
 *	*iret		int		Return code			*
 *					  -2 = Error reading data	*
 **									*
 * Log:									*
 * S. Jacobs/NCEP	11/98						*
 * S. Jacobs/NCEP	 1/99	Removed equivalence of bytes to an int	*
 ***********************************************************************/

{

	int		ier, nbuf, i, iostat, done, ni, nc, iftp, msize;
	unsigned char	buffer[8];
	char		bufr[5];

/*---------------------------------------------------------------------*/

	*iret = 0;

	done = G_FALSE;
	iostat = 0;

	while ( iostat == 0 && ! done )  {

	    cfl_seek ( fpbf, ibcnt, SEEK_SET, &iostat );

	    if  ( iostat == 0 )
		cfl_read ( fpbf, 8, buffer, &nbuf, &iostat );

	    if  ( iostat == 0 )  {
		if  ( buffer[0] == 'B' &&
		      buffer[1] == 'U' &&
		      buffer[2] == 'F' &&
		      buffer[3] == 'R' )  {

		    iftp = buffer[0]*(256*256*256) + 
			   buffer[1]*(256*256) +
			   buffer[2]*(256) +
			   buffer[3];
		    ni = 1;
		    cst_itos ( &iftp, ni, &nc, bufr, &ier );

		    msize = buffer[4]*(256*256) +
			    buffer[5]*(256) +
			    buffer[6];

		    cfl_seek ( fpbf, ibcnt, SEEK_SET, &ier );

		    cfl_read ( fpbf, msize, barray, &nbuf, &ier );

		    if  ( barray[msize-4] == '7' &&
			  barray[msize-3] == '7' &&
			  barray[msize-2] == '7' &&
			  barray[msize-1] == '7' )  {
			*nbytes = msize;

			ibcnt += *nbytes;
		    }
		    else {
			*iret = -2;
			*nbytes = 0;
		    }

		    done = G_TRUE;

		}
		else {
		    ibcnt++;
		}

	    }
	    else {
		*iret = -2;
		*nbytes = 0;
	    }

	}

}
